VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form Form1 
   Caption         =   "RichPic"
   ClientHeight    =   3870
   ClientLeft      =   60
   ClientTop       =   390
   ClientWidth     =   4305
   LinkTopic       =   "Form1"
   ScaleHeight     =   3870
   ScaleWidth      =   4305
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdPutImage 
      Caption         =   "Put Image"
      Height          =   555
      Left            =   1080
      TabIndex        =   1
      Top             =   3240
      Width           =   2295
   End
   Begin RichTextLib.RichTextBox Ri 
      Height          =   3075
      Left            =   0
      TabIndex        =   0
      Top             =   60
      Width           =   4215
      _ExtentX        =   7435
      _ExtentY        =   5424
      _Version        =   393217
      TextRTF         =   $"RichPic.frx":0000
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)

Private Type GSprite24
  Width As Long
  Height As Long
  Data() As Byte
End Type

Private Type BITMAPINFOHEADER '40 bytes
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type
Private Type BITMAPFILEHEADER
  bfType As Integer
  bfSize As Long
  bfReserved1 As Integer
  bfReserved2 As Integer
  bfOffBits As Long
End Type

Private Function RGBWidth(Width As Long) As Long
RGBWidth = (Width * 3 + 3) And &HFFFFFFFC
End Function

Private Function GSprite24_FromBMP24(FN As String, Optional Pos As Long = 1) As GSprite24
'On Error Resume Next
Dim F As Long, BFH As BITMAPFILEHEADER, bih As BITMAPINFOHEADER

F = FreeFile
Open FN For Binary Access Read As #F
  Get #F, Pos, BFH
  Get #F, Pos + Len(BFH), bih
  
  ReDim GSprite24_FromBMP24.Data(1 To RGBWidth(bih.biWidth), 1 To bih.biHeight)
  Get #F, Pos + Len(BFH) + Len(bih), GSprite24_FromBMP24.Data()
  GSprite24_FromBMP24.Width = bih.biWidth
  GSprite24_FromBMP24.Height = bih.biHeight
Erro:
Close #F
End Function

Private Function Hex2(ByVal Value As Byte) As String
Hex2 = Hex$(Value)
If Len(Hex2) < 2 Then Hex2 = "0" & Hex2
End Function

Private Function LongHex(Text As String) As String
Dim i As Long, IC As Long

IC = Len(Text)
LongHex = String(IC * 2, " ")
For i = 1 To IC
  Mid$(LongHex, i * 2 - 1, 2) = Hex2(Asc(Mid$(Text, i, 1)))
Next
End Function

Private Function LongToHEX(ByVal Value As Long) As String
Dim S As String
S = String(4, "0")
CopyMemory ByVal S, Value, 4
LongToHEX = LongHex(S)
End Function

Private Function IntToHEX(ByVal Value As Integer) As String
Dim S As String
S = String(2, "0")
CopyMemory ByVal S, Value, 2
IntToHEX = LongHex(S)
End Function

Private Sub AddToString(Text As String, Add As String, Optional Char As String = vbCrLf)
If Len(Text) = 0 Then Text = Add Else Text = Text & Char & Add
End Sub


Private Function Picture2WMF(ByRef GSprite As GSprite24) As String
Dim VX As Double, VY As Double, LogX As Long, LogY As Long
VX = Screen.TwipsPerPixelX * 2540 / 1440
VY = Screen.TwipsPerPixelY * 2540 / 1440

AddToString Picture2WMF, "0100", ""
AddToString Picture2WMF, "0900", ""
AddToString Picture2WMF, "0003", ""
AddToString Picture2WMF, "00000000", "" 'total size of metafile
AddToString Picture2WMF, "0000", ""
AddToString Picture2WMF, "00000000", "" 'size of largest record in word
AddToString Picture2WMF, "0000", ""

AddToString Picture2WMF, "05000000", ""
AddToString Picture2WMF, "0b02", ""
AddToString Picture2WMF, "0000", ""
AddToString Picture2WMF, "0000", ""

AddToString Picture2WMF, "05000000", ""
AddToString Picture2WMF, "0c02", ""
AddToString Picture2WMF, IntToHEX(GSprite.Width * VX), "" 'log w
AddToString Picture2WMF, IntToHEX(GSprite.Height * VY), "" 'log h

AddToString Picture2WMF, "00000000", ""
AddToString Picture2WMF, "430f", ""
AddToString Picture2WMF, "2000cc00", ""
AddToString Picture2WMF, "0000", ""
AddToString Picture2WMF, IntToHEX(GSprite.Height), "" 'ITSOK
AddToString Picture2WMF, IntToHEX(GSprite.Width), ""
AddToString Picture2WMF, "0000", ""
AddToString Picture2WMF, "0000", ""
AddToString Picture2WMF, IntToHEX(GSprite.Width * VX), ""
AddToString Picture2WMF, IntToHEX(GSprite.Height * VY), ""
AddToString Picture2WMF, "0000", ""
AddToString Picture2WMF, "0000", ""

AddToString Picture2WMF, "28000000", ""
AddToString Picture2WMF, LongToHEX(GSprite.Width), ""
AddToString Picture2WMF, LongToHEX(GSprite.Height), ""
AddToString Picture2WMF, "0100", ""
AddToString Picture2WMF, IntToHEX(24), ""
AddToString Picture2WMF, "00000000", ""
AddToString Picture2WMF, LongToHEX(RGBWidth(GSprite.Width)), ""
AddToString Picture2WMF, "c40e0000", ""
AddToString Picture2WMF, "c40e0000", ""
AddToString Picture2WMF, "00000000", ""
AddToString Picture2WMF, "00000000", ""
Dim S As String
S = String(RGBWidth(GSprite.Width) * GSprite.Height, " ")
CopyMemory ByVal S, GSprite.Data(1, 1), Len(S)
AddToString Picture2WMF, LongHex(S), ""
AddToString Picture2WMF, "03000000", ""
AddToString Picture2WMF, "0000", ""

Mid$(Picture2WMF, 13, 8) = LongToHEX((Len(S) + 40 + 28) / 2 + 22)
Mid$(Picture2WMF, 25, 8) = LongToHEX((Len(S) + 40 + 28) / 2)
Mid$(Picture2WMF, 77, 8) = LongToHEX((Len(S) + 40 + 28) / 2)

Picture2WMF = "{\pict\wmetafile8\picwgoal" & GSprite.Width * Screen.TwipsPerPixelX & "\pichgoal" & GSprite.Height * Screen.TwipsPerPixelY & " " & vbCrLf & Picture2WMF & "}"
End Function


Private Sub cmdPutImage_Click()
Dim S As String

S = Picture2WMF(GSprite24_FromBMP24(App.Path & "\pic.bmp"))
Ri.SelStart = 4
Ri.SelRTF = S
End Sub

